library table;
uses
  SysUtils,
  Forms,
  Controls,
  Dialogs,
  Graphics,
  TblUnit in 'Tblunit.pas' {TableForm};

{$R Table.dcr}
var
  F : TTableForm;
procedure About;
begin
  ShowMessage('Plug-in pro vloen tabulky'+#13#10+'napsal Lubo Horek'+#13#10+'1998');
end;
function Version : string;
begin
  result:='1.00';
end;
function PlugInPic : TBitmap;
begin
  result:=TBitmap.Create;
  result.LoadFromResourceName(HInstance,'TABLE');
end;
function GetName : string;
begin
  result:='Vloen tabulky';
end;
function GetText(Own : pointer;parameter : string;UpCase : Boolean;var optype : Byte;strngs : string;tagstr : string;CurrentPosx : integer;CurrentPosy : Integer) : string;
var
  TagChar : Char; { znak H nebo D, podle toho, zda jde o hlavicku nebo bunku }
  r,c : integer; {pomocne promenne pro radky a sloupce }
  tempstr : String;
function PredelatStr(puvstr : string) : string;
begin
  result:=puvstr;
  if UpCase then result:=UpperCase(puvstr)
    else result:=LowerCase(puvstr);
end;
begin
  result:='text';
  if tagstr<>'' then exit;{ zrovna jsme uvnitr nejakeho tagu}
  if F=nil then
    Application.CreateForm(TTableForm,f);
{    F:=TTableForm.Create(own);}
  F.ShowModal;
  OpType:=255;
  if F.ModalResult=mrOK then begin
   { zapsat <TABLE Border=x> tag }
    result:=PredelatStr('<TABLE BORDER=')+IntToStr(F.BorderTrackBar.Position)+'>'+#13#10;
   { je treba zapsat titulek tabulky ?}
    if Length(F.CaptionEdit.Text)<>0 then result:=result+PredelatStr('<CAPTION>')+
      F.CaptionEdit.Text+PredelatStr('</CAPTION>')+#13#10;
    { zapis vsechny radky }
    for r:=1 to F.TableStringGrid.RowCount do begin
      tempstr:=PredelatStr('<TR>');
      for c:=1 to F.TableStringGrid.ColCount do begin
        if (r<=F.FR) OR (c<=F.FC) then
          TagChar:='H' else TagChar:='D';
          tempstr:=tempstr+PredelatStr('<T'+TagChar+'>')+F.TableStringGrid.Cells[c-1,r-1];
        if F.CloseTagCheckBox.Checked then tempstr:=tempstr+PredelatStr('</T'+TagChar+'>');
      end;
      if F.CloseTagCheckBox.Checked then tempstr:=tempstr+PredelatStr('</TR>');
      result:=result+tempstr+#13#10;
    end;
    result:=result+PredelatStr('</TABLE>')+#13#10;
    OpType:=0;
  end;
  F.Destroy;
end;
exports
  About,
  Version,
  PlugInPic,
  GetName,
  GetText;
end.
