{ formular pro vlozeni tabulky }
unit TblUnit;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls, ComCtrls;
type
   { definice formulare }
  TTableForm = class(TForm)
    TableStringGrid: TStringGrid {StringGrid pro tabulku};
    TopPanel: TPanel {horni panel dialogu};
    BottomPanel: TPanel {dolni panel dialogu};
    OKButton: TButton {tlacitko OK};
    CancelButton: TButton {tlacitko Storno};
     { labely dialogu }
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
     { Up/Down controly pro volbu poctu radku/sloupcu tabulky/legendy}
    RowsUpDown: TUpDown;
    ColsUpDown: TUpDown;
    HeadRowsUpDown: TUpDown;
    HeadColsUpDown: TUpDown;
    CaptionEdit: TEdit { vstupni radka pro nazev tabulky};
    BorderTrackBar: TTrackBar { track bar pro volbu tloustky mrizky };
    CloseTagCheckBox: TCheckBox { check box pro volbu uzavirani tagu};
    ButtonPanel: TPanel;
    procedure RowsUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure FormCreate(Sender: TObject);
    procedure BorderTrackBarChange(Sender: TObject);
    procedure TableStringGridDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    Fc,Fr : Integer;
    { Public declarations }
  end;
implementation

{$R *.DFM}
{ zmena nektereho UPDownu }
procedure TTableForm.RowsUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
  TableStringGrid.RowCount:=101-RowsUpDown.Position+100-HeadRowsUpDown.Position;
  TableStringGrid.ColCount:=ColsUpDown.Position+HeadColsUpDown.Position;
  FR:=100-HeadRowsUpDown.Position;
  FC:=HeadColsUpDown.Position;
  TableStringGrid.Repaint;
end;
{ vytvoreni formulare}
procedure TTableForm.FormCreate(Sender: TObject);
begin
  RowsUpDownClick(@self,btNext);{ inicializace tabulky (pocet radek,sloupcu)}
end;
{ zmena track baru sirky okraje bunek }
procedure TTableForm.BorderTrackBarChange(Sender: TObject);
begin
  { zmenit sirku okraje}
  TableStringGrid.GridLineWidth:=BorderTrackBar.Position;
end;
procedure TTableForm.TableStringGridDrawCell(Sender: TObject; Col,
  Row: Integer; Rect: TRect; State: TGridDrawState);
begin
  With TableStringGrid.canvas do begin
    if ((row+1)<=FR) OR ((col+1)<=FC) then begin
      Brush.Color:=clBlue;
      Font.Color:=clWhite;
    end else begin
      Brush.Color:=clWhite;
      Font.Color:=clBlack;
    end;
    if state=[gdSelected,gdFocused] then begin
      Brush.Color:=clSilver;
      Font.Color:=clBlack;
    end;
    FillRect(Rect);
    TextOut(Rect.Left,Rect.Top,TableStringGrid.Cells[col,row]);
  end;
end;

end.
